#!/usr/bin/env python
# $Id$
''' List email in a pop3 mailbox '''

import poplib, email
from getpass import getpass

def setup_mail(host, user, passwd, ssl=True, port=None):
    ''' Setup connection to email server '''
    if ssl:
        if not port:
            port = 995
        pop3 = poplib.POP3_SSL(host, port)            
    else:
        if not port:
            port = 110
        pop3 = poplib.POP3(host, port)
    pop3.user(user)
    pop3.pass_(passwd)
    return pop3

def display(pop3, user, start_index=1):
    '''List email subjects from remote pop host '''
    num = len(pop3.list()[1])
    print user, " has ", num, " messages."

    format = "%-3s %-20s %s"

    if num > 0:
        print format % ("Num", "From", "Subject")
        for i in range(start_index, num+1):
            string = '\n'.join(pop3.top(i, 1)[1])
            msg = email.message_from_string(string)
            print format % (i, msg["From"], msg["Subject"])
    pop3.quit()

def last(pop3, index):
    ''' Calculate index offset of most recent messages '''
    num = len(pop3.list()[1])
    if index > num:
        return 1
    else:
        return num - index

def get_passwd(host):
    ''' Get user's password '''
    return getpass("Enter your password for %s: " % host)

# vim:syntax=python
# vim:sw=4:softtabstop=4:expandtab
